# Copyright 2004, Rick Wilson 

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          crate.rb 1.0
# Description :   Makes inset faces in faces
# Author :        Rick Wilson
# Usage :         1. Install into the plugins directory or into the 
#                    Plugins/examples directory and manually load from the ruby console "load 'examples/crate.rb'" 
#                 2. Run "Make inset faces in faces" from the Plugins menu.
# Date :          27.Jul.2004
# Type :          Tool
# History:        1.0 (20.Jul.2004) - first version
#                 1.1 (20.Nov.2004) -  elevate option added by: Tim

require 'sketchup.rb'
require 'offset.rb'

def crate_in
    
	model=Sketchup.active_model
	ents=model.active_entities
	sel=model.selection
    
    if sel.empty? 
      UI.messagebox("Pas de selection !")
      return nil
    end
        
	prompts=["Decalage exterieur ","Decalage interieur "]
	 if not ($o_dist && $inset)
		values=[-3.0.inch,-3.0.inch]
	else
		values=[$o_dist,$inset]
	end
	$o_dist,$inset=inputbox(prompts,values,"Parametres")
    
    if ($o_dist > 0 )
       UI.messagebox( "Valeurs positives interdites ")
    return nil
    end
    
    if ($inset > 0)
       UI.messagebox( "Valeurs positives interdites ")
    return nil
    end
    
	for ent in sel
		if ent.class == Sketchup::Face
			$newface=ent.offset ($o_dist)
			$newface.pushpull ($inset)
		end
	end
	#sel.clear
end
#----------------------------------------------------------------------
def crate_out
    
	model=Sketchup.active_model
	ents=model.active_entities
	sel=model.selection
    
    if sel.empty? 
      UI.messagebox("Pas selection !")
      return nil
    end
    
	prompts=["Decalage exterieur ","Distance en elevation "]
       
	 if not ($o_dist && $inset)
		values=[-3.0.inch,-3.0.inch]
	else
		values=[$o_dist,$inset]
	end
	$o_dist,$inset=inputbox(prompts,values,"Elevation")
    
    if ($o_dist > 0 )
       UI.messagebox( "Valeurs positives interdites ")
    return nil
    end
    
    if ($inset > 0)
       UI.messagebox( "Valeurs positives interdites ")
    return nil
    end
    
	for ent in sel
		if ent.class == Sketchup::Face
			$newface=ent.offset ($o_dist)
			$newface.pushpull (-$inset)
		end
	end
	sel.clear
end
#-----------------------------------------------------------------------
if (not file_loaded?("fr_crate1.rb"))
    utilities_menu = UI.menu("Plugins").add_submenu("Claire-voie")
         utilities_menu.add_item("Creuser des faces en claire-voie") { crate_in }
         utilities_menu.add_item("Elever des faces en claire-voie") { crate_out }
end
file_loaded("fr_crate1.rb")
